'Oom010 (1/23/1999 6:20:33 pm)'.!


StringHolderController subclass: #OomPluggableStringHolderController
	instanceVariableNames: 'localMenuSelectors menuHolder performer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Pluggable-Support'!
!OomPluggableStringHolderController commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomPluggableStringHolderController methodsFor: 'initialize-release' stamp: 'nishis 7/24/1998 21:49'!
initialize
	super initialize.
	localMenuSelectors := #(find findAgain setSearchString again undo copySelection cut paste doIt printIt inspectIt accept cancel).
	performer := self.
	menuHolder := []! !


!OomPluggableStringHolderController methodsFor: 'accessing'!
localMenuSelectors
	^localMenuSelectors! !

!OomPluggableStringHolderController methodsFor: 'accessing'!
localMenuSelectors: selectorArray
	localMenuSelectors := selectorArray! !

!OomPluggableStringHolderController methodsFor: 'accessing' stamp: 'nishis 7/24/1998 17:31'!
menu
	^self menuHolder value! !

!OomPluggableStringHolderController methodsFor: 'accessing' stamp: 'nishis 7/24/1998 17:31'!
menuHolder
	^menuHolder! !

!OomPluggableStringHolderController methodsFor: 'accessing' stamp: 'nishis 7/24/1998 17:31'!
menuHolder: aMenuHolder
	menuHolder := aMenuHolder! !

!OomPluggableStringHolderController methodsFor: 'accessing' stamp: 'nishis 7/24/1998 17:31'!
performer
	^performer! !

!OomPluggableStringHolderController methodsFor: 'accessing' stamp: 'nishis 7/24/1998 17:31'!
performer: anObject
	performer := anObject! !


!OomPluggableStringHolderController methodsFor: 'menu messages' stamp: 'nishis 7/24/1998 19:16'!
accept 
	super accept.
	initialText := paragraph text copy.
	self view contents: paragraph string! !

!OomPluggableStringHolderController methodsFor: 'menu messages' stamp: 'nishis 7/24/1998 21:57'!
yellowButtonActivity
	| menu selector |
	menu := self menu.
	menu isNil ifTrue: [menu := self view menu].
	menu isNil
		ifTrue: [super controlActivity]
		ifFalse: 
			[selector := menu startUp.
			selector isNil 
				ifFalse:
					[(performer respondsTo: selector)
						ifTrue: 
							[self sendMenuMessageTo: performer selector: selector]
						ifFalse:
							[(self localMenuSelectors includes: selector)
								ifTrue: [self menuMessageReceiver performMenuMessage: selector]
								ifFalse: [self sendMenuMessageToModel: selector]]]]! !


!OomPluggableStringHolderController methodsFor: 'pluggable support' stamp: 'nishis 7/24/1998 18:07'!
sendMenuMessageTo: receiver selector: selector
	| kind arguments |
	self controlTerminate.
	kind := selector numArgs.
	arguments := nil.
	kind = 0 ifTrue: [arguments := Array new].
	kind = 1 ifTrue: [arguments := Array with: self selection asString].
	kind = 2 ifTrue: [arguments := Array with: self selection asString with: paragraph asString].
	kind = 3 ifTrue: [arguments := Array with: self selection asString with: paragraph asString with: self].
	arguments notNil ifTrue: [receiver perform: selector withArguments: arguments].
	self controlInitialize! !

!OomPluggableStringHolderController methodsFor: 'pluggable support' stamp: 'nishis 7/24/1998 18:07'!
sendMenuMessageToModel: selector
	self sendMenuMessageTo: self model selector: selector! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomPluggableStringHolderController class
	instanceVariableNames: ''!

!OomPluggableStringHolderController class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomPluggableStringHolderController class methodsFor: 'copyright' stamp: 'nishis 11/14/1998 13:41'!
readme
	"Originally written by Mr. AOKI Atsushi, modified by nishis."! !

!OomPluggableStringHolderController class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomPluggableStringHolderController class methodsFor: 'copyright'!
version
	^'010'! !
