'Oom010 (1/23/1999 6:20:42 pm)'.!


Model subclass: #OomListenerModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Models'!
!OomListenerModel commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomListenerModel methodsFor: 'initialize-release' stamp: 'nishis 7/27/1998 08:36'!
initialize
	^self! !

!OomListenerModel methodsFor: 'initialize-release' stamp: 'nishis 7/27/1998 08:36'!
release
	super release! !


!OomListenerModel methodsFor: 'accessing' stamp: 'nishis 7/29/1998 00:34'!
setValue: newValue
	^self subclassResponsibility! !

!OomListenerModel methodsFor: 'accessing' stamp: 'nishis 7/27/1998 08:40'!
value
	^self subclassResponsibility! !

!OomListenerModel methodsFor: 'accessing' stamp: 'nishis 7/27/1998 16:42'!
value: newValue
	self setValue: newValue.
	self changed: #value! !


!OomListenerModel methodsFor: 'constructing' stamp: 'nishis 7/28/1998 23:38'!
compute: aBlock
	^OomBlockListener 
		block: aBlock 
		arguments: (Array with: self)! !

!OomListenerModel methodsFor: 'constructing' stamp: 'nishis 7/28/1998 23:37'!
receive: aSelector
	^OomBlockListener 
		block: [:receiver | receiver perform: aSelector]
		arguments: (Array with: self)! !

!OomListenerModel methodsFor: 'constructing' stamp: 'nishis 7/28/1998 23:37'!
receive: aSelector with: value
	^OomBlockListener 
		block: [:receiver :argument | receiver perform: aSelector with: argument]
		arguments: (Array with: self with: value)! !

!OomListenerModel methodsFor: 'constructing' stamp: 'nishis 7/28/1998 23:38'!
with: value compute: aBlock
	^OomBlockListener 
		block: aBlock 
		arguments: (Array with: self with: value)! !

!OomListenerModel methodsFor: 'constructing' stamp: 'nishis 7/28/1998 23:38'!
with: value1 with: value2 compute: aBlock
	^OomBlockListener 
		block: aBlock 
		arguments: (Array with: self with: value1 with: value2)! !


!OomListenerModel methodsFor: 'updating' stamp: 'nishis 7/29/1998 03:37'!
changed: aspectSymbol 
	| aContext |
	aContext := thisContext.
	(self isLoop: aContext sender context: aContext) 
		ifFalse: 
			[self dependents do: [:aDependent | aDependent update: aspectSymbol]]! !

!OomListenerModel methodsFor: 'updating' stamp: 'nishis 7/29/1998 22:21'!
originalChanged: aspectSymbol with: aParameter
	"see AOKI Atsushi, ""Smalltalk Idioms"", p.236, SRC, 1997, Tokyo, ISBN4-915778-81-9 C3055 P4500E."

"
	| aContext |
	aContext := thisContext.
	aBlock := 
		[:context | 
		(aContext receiver = context receiver and: [aContext selector = context selector]) 
			ifTrue: [^self].
		context sender isNil ifFalse: [aBlock value: context sender]].
	aBlock value: aContext sender.
	self myDependents
		update: aspectSymbol
		with: aParameter
		from: self
"! !


!OomListenerModel methodsFor: 'interests' stamp: 'nishis 11/14/1998 12:01'!
onChangeSend: aSymbol to: anObject 
	^self notYetImplemented
	"^OomBlockListener 
		block: aBlock 
		arguments: (Array with: self)"! !


!OomListenerModel methodsFor: 'private' stamp: 'nishis 7/29/1998 22:20'!
isLoop: aSenderOfContext context: aContext
	(aContext receiver = aSenderOfContext receiver and: 
				[aContext selector = aSenderOfContext selector]) 
		ifTrue: [^true].
	aSenderOfContext sender isNil 
		ifFalse: 
			[^self isLoop: aSenderOfContext sender context: aContext].
	^false! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomListenerModel class
	instanceVariableNames: ''!

!OomListenerModel class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomListenerModel class methodsFor: 'copyright' stamp: 'nishis 11/14/1998 13:32'!
readme
	"I am an fake ValueModel."

	"see useful messages below"
	"http://www.sra.co.jp/smalltalk/SML/mails/301-400/331.txt"
	"http://www.sra.co.jp/smalltalk/SML/mails/301-400/381.txt"! !

!OomListenerModel class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomListenerModel class methodsFor: 'copyright'!
version
	^'010'! !


!OomListenerModel class methodsFor: 'instance creation' stamp: 'nishis 7/27/1998 08:41'!
new
	^super new initialize! !
