'Oom010 (1/23/1999 6:20:43 pm)'.!


OomScheduledView subclass: #OomAlteredScheduledView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Display'!
!OomAlteredScheduledView commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomAlteredScheduledView methodsFor: 'controller access' stamp: 'nishis 5/15/98 23:02'!
defaultControllerClass
	^OomAlteredScheduledController! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomAlteredScheduledView class
	instanceVariableNames: ''!

!OomAlteredScheduledView class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomAlteredScheduledView class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomAlteredScheduledView class methodsFor: 'copyright'!
version
	^'010'! !


!OomAlteredScheduledView class methodsFor: 'instance creation' stamp: 'nishis 5/15/98 23:33'!
model: aModel label: aString minimumSize: aPoint
	| scheduledView |
	scheduledView := self new.
	scheduledView model: aModel.
	scheduledView label: aString.
	scheduledView minimumSize: aPoint + scheduledView labelOffset..
	scheduledView borderWidth: 1.
	^scheduledView! !

!OomAlteredScheduledView class methodsFor: 'instance creation' stamp: 'nishis 5/15/98 23:33'!
model: aModel label: aString minimumSize: minimumPoint maximumSize: maximumPoint 
	| scheduledView |
	scheduledView := self model: aModel label: aString minimumSize: minimumPoint.
	scheduledView maximumSize: maximumPoint + scheduledView labelOffset.
	^scheduledView! !


!OomAlteredScheduledView class methodsFor: 'examples' stamp: 'nishis 5/15/98 23:41'!
example1
	"OomAlteredScheduledView example1."

	| topView |
	topView := OomAlteredScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200
		maximumSize: 300 @ 200.
	topView controller open! !

!OomAlteredScheduledView class methodsFor: 'examples' stamp: 'nishis 5/15/98 23:40'!
example2
	"OomAlteredScheduledView example2."

	| topView leftView rightView |
	topView := OomAlteredScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200.
	leftView := View new.
	leftView borderWidth: 1.
	leftView backgroundColor: Color red.
	topView addSubView: leftView.
	rightView := View new.
	rightView borderWidth: 1.
	rightView backgroundColor: Color green.
	topView addSubView: rightView toRightOf: leftView.
	topView controller openIn: (100 @ 100 extent: topView minimumSize)
! !

!OomAlteredScheduledView class methodsFor: 'examples' stamp: 'nishis 7/20/1998 02:16'!
example3
	"OomAlteredScheduledView example3."

	| topView leftView rightView |
	topView := OomAlteredScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200
		maximumSize: 300 @ 200.
	leftView := View new.
	leftView borderWidth: 1.
	leftView backgroundColor: Color red.
	topView addSubView: leftView.
	rightView := View new.
	rightView borderWidth: 1.
	rightView backgroundColor: Color green.
	topView addSubView: rightView toRightOf: leftView.
	topView controller openAt: 100 @ 100! !
