'Oom010 (1/23/1999 6:20:44 pm)'.!


OomAbstractModel subclass: #OomPopularityModel
	instanceVariableNames: 'sample ranking vertical horizontal color log '
	classVariableNames: 'PopularityMenu '
	poolDictionaries: ''
	category: 'Oom-Interface-Popularity'!
!OomPopularityModel commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:53'!
color
	color isNil ifTrue: [color := Color red].
	^color! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:53'!
color: colorValue 
	color := colorValue.
	self changed: #ranking! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:53'!
flush
	ranking := nil! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:53'!
horizontal
	^horizontal! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:53'!
horizontal: aString
	horizontal := aString.
	self changed: #description! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:53'!
log
	^log = true! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:54'!
log: aBoolean 
	| old |
	old := self log.
	log := aBoolean = true.
	old = log ifFalse: [self changed: #sample]! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:54'!
sample
	^sample! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:54'!
sample: aCollection 
	sample := aCollection.
	self flush.
	self changed: #sample! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:54'!
vertical
	^vertical! !

!OomPopularityModel methodsFor: 'accessing' stamp: 'nishis 7/18/1998 14:54'!
vertical: aString 
	vertical := aString.
	self changed: #description! !


!OomPopularityModel methodsFor: 'functions' stamp: 'nishis 7/18/1998 14:55'!
average
	| count |
	count := self count.
	count = 0 ifTrue: [^0].
	^self total / count! !

!OomPopularityModel methodsFor: 'functions' stamp: 'nishis 7/18/1998 14:55'!
count
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	^self sample size! !

!OomPopularityModel methodsFor: 'functions' stamp: 'nishis 7/18/1998 14:55'!
deviation
	| average count value v |
	average := self average.
	count := self count.
	count = 0 ifTrue: [^0].
	value := 0.
	self sample
		do: 
			[:each | 
			v := each.
			v := v - average.
			v := v * v.
			value := value + v].
	^(value / (count - 1)) sqrt! !

!OomPopularityModel methodsFor: 'functions' stamp: 'nishis 7/18/1998 14:55'!
maximum
	| maximum |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	maximum := nil.
	self sample do: [:each | maximum isNil
			ifTrue: [maximum := each]
			ifFalse: [maximum := maximum max: each]].
	^maximum! !

!OomPopularityModel methodsFor: 'functions' stamp: 'nishis 7/18/1998 14:55'!
minimum
	| minimum |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	minimum := nil.
	self sample do: [:each | minimum isNil
			ifTrue: [minimum := each]
			ifFalse: [minimum := minimum min: each]].
	^minimum! !

!OomPopularityModel methodsFor: 'functions' stamp: 'nishis 7/18/1998 14:56'!
ranking
	| collection |
	ranking notNil ifTrue: [^ranking].
	(self sample isNil or: [self sample isEmpty])
		ifTrue: 
			[ranking := Array new.
			^ranking].
	collection := SortedCollection new: self sample size.
	collection sortBlock: [:x :y | x > y].
	self sample do: [:each | collection add: each].
	ranking := Array new: collection size.
	1 to: collection size do: [:index | ranking at: index put: index -> (collection at: index)].
	^ranking! !

!OomPopularityModel methodsFor: 'functions' stamp: 'nishis 7/18/1998 15:01'!
total
	| total |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	total := 0.
	self sample do: [:each | total := total + each].
	^total! !


!OomPopularityModel methodsFor: 'menu messages' stamp: 'nishis 7/18/1998 14:56'!
changeLog
	self log ifFalse: [self log: true]! !

!OomPopularityModel methodsFor: 'menu messages' stamp: 'nishis 7/18/1998 14:56'!
changeNum
	self log ifTrue: [self log: false]! !

!OomPopularityModel methodsFor: 'menu messages' stamp: 'nishis 7/18/1998 19:18'!
showClasses: value 
	| collection |
	(self sample respondsTo: #associationsDo:)
		ifFalse: [^self].
	collection := SortedCollection sortBlock: [:a1 :a2 | a1 key < a2 key].
	self sample associationsDo: [:assoc | value = assoc value ifTrue: [collection add: assoc]].
	collection isEmpty ifTrue: [^self].
	OomFakeDialog
				model: self
				choose: 'Which of these classes or messages do you browse?'
				fromList: (collection collect: [:assoc | assoc key asString , ' (' , assoc value printString , ')'])
				values: (collection collect: [:assoc | assoc key])
				lines: 10
				cancel: [nil]! !

!OomPopularityModel methodsFor: 'menu messages' stamp: 'nishis 7/19/1998 12:31'!
showItem: target 
	target isNil ifTrue: [^self].
	OomTableMetrics browse: target
! !

!OomPopularityModel methodsFor: 'menu messages' stamp: 'nishis 11/14/1998 12:08'!
yellowButtonMenu
	"OomPopularityModel flushMenus."

	| collection menu |
	PopularityMenu isNil
		ifTrue: 
			[collection := OrderedCollection new.
			collection add: 'normal' -> #changeNum.
			collection add: 'log-log' -> #changeLog.
			menu := OomMenuMaker fromCollection: collection.
			PopularityMenu := menu].
	^PopularityMenu
! !


!OomPopularityModel methodsFor: 'interface opening' stamp: 'nishis 11/12/1998 22:19'!
open
	"OomPopularityModel new open"

	| topView view |
	view := self popularityView.
	view  borderWidth: 1.
	topView := OomScheduledView
			model: view model 
			label: 'Popularity' 
			minimumSize: 300 @ 200.
	topView addSubView: view.
	self postBuildWith: topView.
	OomUtilities openReframe: topView! !

!OomPopularityModel methodsFor: 'interface opening' stamp: 'nishis 7/18/1998 14:58'!
popularityView
	| aView |
	aView := OomPopularityView new.
	aView model: self.
	^aView! !


!OomPopularityModel methodsFor: 'printing' stamp: 'nishis 7/18/1998 14:59'!
printOn: aStream 
	| collection |
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' ('.
	aStream cr.
	aStream nextPutAll: '  ranking:'.
	aStream cr.
	collection := self ranking.
	collection
		do: 
			[:assoc | 
			aStream space; space; space; space.
			aStream nextPutAll: assoc printString.
			aStream cr].
	aStream nextPutAll: '  count:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self count printString.
	aStream cr.
	aStream nextPutAll: '  average:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self average asFloat printString.
	aStream cr.
	aStream nextPutAll: '  deviation:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self deviation asFloat printString.
	aStream cr.
	aStream nextPutAll: ')'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomPopularityModel class
	instanceVariableNames: ''!

!OomPopularityModel class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomPopularityModel class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomPopularityModel class methodsFor: 'copyright'!
version
	^'010'! !


!OomPopularityModel class methodsFor: 'class initialization' stamp: 'nishis 7/18/1998 14:30'!
flushMenus
	"OomPopularityModel flushMenus."

	PopularityMenu := nil! !


!OomPopularityModel class methodsFor: 'instance creation' stamp: 'nishis 7/18/1998 14:50'!
sample: aCollection 
	^(self new) sample: aCollection; yourself! !


!OomPopularityModel class methodsFor: 'examples' stamp: 'nishis 7/18/1998 14:51'!
example1
	"OomPopularityModel example1."

	| collection popularity |
	collection := OrderedCollection new.
	collection add: 0.
	collection add: 10.
	collection add: 20.
	collection add: 30.
	collection add: 35.
	collection add: 40.
	collection add: 45.
	collection add: 48.
	collection add: 50.
	collection add: 52.
	collection add: 55.
	collection add: 60.
	collection add: 65.
	collection add: 70.
	collection add: 80.
	collection add: 90.
	collection add: 100.
	popularity := OomPopularityModel sample: collection.
	Transcript cr; show: popularity printString.
	^popularity! !

!OomPopularityModel class methodsFor: 'examples' stamp: 'nishis 7/18/1998 14:52'!
example2
	"OomPopularityModel example2."

	| classes calculator progress dictionary popularity |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricCP classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [dictionary := calculator compute].
	popularity := OomPopularityModel sample: dictionary.
	Transcript cr; show: popularity printString.
	^popularity! !

!OomPopularityModel class methodsFor: 'examples' stamp: 'nishis 7/18/1998 14:52'!
example3
	"OomPopularityModel example3."

	| classes calculator progress dictionary popularity |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricMP classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [dictionary := calculator compute].
	popularity := OomPopularityModel sample: dictionary.
	popularity horizontal: calculator description , ' ranking'.
	popularity vertical: calculator description.
	popularity open.
	^popularity! !

!OomPopularityModel class methodsFor: 'examples' stamp: 'nishis 7/18/1998 14:52'!
example4
	"OomPopularityModel example4."

	| classes calculator progress dictionary popularity |
	classes := OomMetricAbstract allClasses.
	calculator := OomMetricMP classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [dictionary := calculator compute].
	popularity := OomPopularityModel sample: dictionary.
	popularity horizontal: calculator description , ' ranking'.
	popularity vertical: calculator description.
	popularity open.
	^popularity! !
