'Oom010 (1/23/1999 6:20:46 pm)'.!


OomTableMetrics subclass: #OomBasicMetrics
	instanceVariableNames: ''
	classVariableNames: 'BasicMenu '
	poolDictionaries: ''
	category: 'Oom-Metrics-Tool'!
!OomBasicMetrics commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomBasicMetrics methodsFor: 'accessing' stamp: 'nishis 11/13/1998 17:46'!
formatTable
	^#('name' 0 0 0 0 0 0 0)! !

!OomBasicMetrics methodsFor: 'accessing' stamp: 'nishis 7/24/1998 12:50'!
metricClasses
	| collection |
	collection := OrderedCollection new.
	collection add: OomMetricLOC.
	collection add: OomMetricNOM.
	collection add: OomMetricNIM.
	collection add: OomMetricNCM.
	collection add: OomMetricNOA.
	collection add: OomMetricNIV.
	collection add: OomMetricNCV.
	^collection! !


!OomBasicMetrics methodsFor: 'interface opening' stamp: 'nishis 11/14/1998 20:24'!
open
	| topView view preferredBounds |
	view := self createTableView.
	view  borderWidth: 1.
	preferredBounds := view preferredBounds expandBy: 2.
	topView := OomScheduledView
			model: view model 
			label: 'Basic Metrics' 
			minimumSize: preferredBounds extent x @ 200.
	topView addSubView: view.
	OomUtilities openReframe: topView! !


!OomBasicMetrics methodsFor: 'menu messages' stamp: 'nishis 11/7/1998 04:37'!
yellowButtonMenu
	"OomBasicMetrics flushMenus."

	| collection menu |
	BasicMenu isNil
		ifTrue: 
			[collection := OrderedCollection new.
			collection add: 'classes' -> #selectClasses.
			collection add: 'compute' -> #computeValues.
			collection add: nil.
			collection add: 'load' -> #loadValues.
			collection add: 'save' -> #saveValues.
			collection add: 'save as html' -> #saveValuesAsHtml.
			menu := OomMenuMaker fromCollection: collection.
			BasicMenu := menu].
	"self readOnly
		ifTrue: 
			[(BasicMenu menuItemLabeled: 'classes') disable.
			(BasicMenu menuItemLabeled: 'compute') disable]
		ifFalse: 
			[(BasicMenu menuItemLabeled: 'classes') enable.
			(BasicMenu menuItemLabeled: 'compute') enable]."
	^BasicMenu! !


!OomBasicMetrics methodsFor: 'private' stamp: 'nishis 7/20/1998 03:23'!
filePrefix
	^'BS' copy! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomBasicMetrics class
	instanceVariableNames: ''!

!OomBasicMetrics class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomBasicMetrics class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomBasicMetrics class methodsFor: 'copyright'!
version
	^'010'! !


!OomBasicMetrics class methodsFor: 'class initialization' stamp: 'nishis 7/20/1998 03:24'!
flushMenus
	"OomBasicMetrics flushMenus."

	BasicMenu := nil! !


!OomBasicMetrics class methodsFor: 'examples' stamp: 'nishis 7/20/1998 03:25'!
example1
	"OomBasicMetrics example1."

	| metrics |
	metrics := OomBasicMetrics new.
	metrics open.
	^metrics! !
