'Oom010 (1/23/1999 6:20:32 pm)'.!


Object subclass: #OomFakeDialog
	instanceVariableNames: 'model list selection values view topView '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Support'!
!OomFakeDialog commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomFakeDialog methodsFor: 'initialization' stamp: 'nishis 6/11/1998 21:51'!
initialize
	list := #().
	selection := 0! !


!OomFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 04:42'!
list
	^list! !

!OomFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:22'!
list: aList
	list := aList! !

!OomFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:13'!
model
	^model! !

!OomFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:13'!
model: aModel
	model := aModel! !

!OomFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 04:42'!
selection
	^selection! !

!OomFakeDialog methodsFor: 'accessing' stamp: 'nishis 6/11/1998 21:49'!
selection: index
	selection := index.
	self changed: #selection! !

!OomFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:08'!
values
	^values! !

!OomFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:09'!
values: theValues
	values := theValues! !


!OomFakeDialog methodsFor: 'interface opening' stamp: 'nishis 11/12/1998 22:20'!
model: aModel choose: message fromList: aList values: theValues lines: lines cancel: cancel
	| listView displayPoint |
	self list: aList.
	self values: theValues.
	self model: aModel.
	listView :=
		PluggableListView on: self
			list: #list
			selected: #selection
			changeSelected: #selection:
			menu: #menu:.
	view := listView.
	topView := OomAlteredScheduledView 
		model: self
		label: message
		minimumSize: 324 @ 200.
	topView addSubView: listView.
	topView borderWidth: 1.
	displayPoint := Display boundingBox center -  (topView minimumSize / 2) asPoint.
	topView controller openAt: displayPoint.
	^topView! !


!OomFakeDialog methodsFor: 'interface closing' stamp: 'nishis 11/9/1998 10:14'!
close
	topView controller closeAndUnschedule! !


!OomFakeDialog methodsFor: 'menu' stamp: 'nishis 6/11/1998 21:57'!
menu: aMenu
	^ aMenu addList: #(
		(Accept acceptCmd)
		(Cancel cancelCmd))! !


!OomFakeDialog methodsFor: 'menu commands' stamp: 'nishis 7/24/1998 00:10'!
acceptCmd
	| index |
	index := view getCurrentSelectionIndex.
	index < 1 ifTrue: [^nil].
	(self model respondsTo: #showItem:) ifTrue: [self model perform: #showItem: with: (values at: index)]! !

!OomFakeDialog methodsFor: 'menu commands' stamp: 'nishis 7/24/1998 01:30'!
cancelCmd
	"do nothig"! !


!OomFakeDialog methodsFor: 'code pane menu' stamp: 'nishis 11/14/1998 12:15'!
perform: selector orSendTo: otherTarget
	"see StringHolder class>>perform:orSendTo:"
	| result |
	(self respondsTo: selector)
		ifTrue: [result := self perform: selector]
		ifFalse: [result := otherTarget perform: selector].
	result notNil ifTrue: [self close].
	^result! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomFakeDialog class
	instanceVariableNames: ''!

!OomFakeDialog class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomFakeDialog class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomFakeDialog class methodsFor: 'copyright'!
version
	^'010'! !


!OomFakeDialog class methodsFor: 'instance creation' stamp: 'nishis 5/24/98 06:46'!
model: aModel choose: message fromList: aList values: values lines: lines cancel: cancel
	| list |
	list := self new initialize.
	^list 
		model: aModel 
		choose: message 
		fromList: aList 
		values: values 
		lines: lines 
		cancel: cancel! !


!OomFakeDialog class methodsFor: 'examples' stamp: 'nishis 11/9/1998 10:24'!
example1
	"OomFakeDialog example1."

	| collection |
	collection := Smalltalk classNames.
	^OomFakeDialog
		model: nil 
		choose: 'Which of these classes do you select?'
		fromList: collection
		values: collection
		lines: 10
		cancel: [nil]! !
