'Oom010 (1/23/1999 6:20:33 pm)'.!


StandardSystemController subclass: #OomScheduledController
	instanceVariableNames: 'menuHolder performer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Display'!
!OomScheduledController commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomScheduledController methodsFor: 'initialize-release' stamp: 'nishis 7/25/1998 04:26'!
initialize
	super initialize.
	performer := self.
	menuHolder := []! !


!OomScheduledController methodsFor: 'accessing' stamp: 'nishis 7/25/1998 04:26'!
menu
	^self menuHolder value! !

!OomScheduledController methodsFor: 'accessing' stamp: 'nishis 7/25/1998 04:26'!
menuHolder
	^menuHolder! !

!OomScheduledController methodsFor: 'accessing' stamp: 'nishis 7/25/1998 04:26'!
menuHolder: aMenuHolder
	menuHolder := aMenuHolder! !

!OomScheduledController methodsFor: 'accessing' stamp: 'nishis 7/25/1998 04:26'!
performer
	^performer! !

!OomScheduledController methodsFor: 'accessing' stamp: 'nishis 7/25/1998 04:26'!
performer: anObject
	performer := anObject! !


!OomScheduledController methodsFor: 'menu messages'!
toggleTwoTone
	"do nothing"! !


!OomScheduledController methodsFor: 'scheduling'!
openAt: aPoint
	self openIn: (aPoint extent: self view minimumSize)! !

!OomScheduledController methodsFor: 'scheduling' stamp: 'nishis 11/14/1998 11:54'!
openIn: aRectangle
	| displayRectangle minimumExtent |
	view minimumSize isNil
		ifTrue: [view resizeTo: aRectangle]
		ifFalse:
			[minimumExtent := view minimumSize max: aRectangle extent.
			displayRectangle := aRectangle origin extent: minimumExtent.
			view resizeTo: displayRectangle].
	"Sensor cursorPoint: view insetDisplayBox center."
	status := #open.
	ScheduledControllers scheduleActive: self! !


!OomScheduledController methodsFor: 'basic control sequence' stamp: 'nishis 7/20/1998 02:51'!
controlTerminate
	super controlTerminate.
	Cursor normal show! !


!OomScheduledController methodsFor: 'control defaults' stamp: 'nishis 11/14/1998 11:54'!
controlActivity
	(Sensor redButtonPressed and: [self viewHasCursor])
		ifTrue: [^self redButtonActivity].
	(Sensor yellowButtonPressed and: [self viewHasCursor])
		ifTrue: [^self yellowButtonActivity].
	super controlActivity! !

!OomScheduledController methodsFor: 'control defaults' stamp: 'nishis 7/20/1998 04:37'!
yellowButtonActivity
	| menu selector |
	self model isNil ifTrue: [^self].
	(menu := self model yellowButtonMenu) isNil ifTrue: [^self].
	self controlTerminate.
	selector := menu startUp.
	(selector isNil or: [selector = 0])
		ifFalse: [self model perform: selector].
	self controlInitialize! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomScheduledController class
	instanceVariableNames: ''!

!OomScheduledController class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomScheduledController class methodsFor: 'copyright' stamp: 'nishis 11/14/1998 13:41'!
readme
	"Originally written by Mr. AOKI Atsushi, modified by nishis."

	"ScheduledController."
	"Goodies-ScheduledVC, version 002."
	"Copyright (C) 1986-1998 AOKI Atsushi, All Rights Reserved."! !

!OomScheduledController class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomScheduledController class methodsFor: 'copyright'!
version
	^'010'! !


!OomScheduledController class methodsFor: 'examples'!
example1
	"OomScheduledController example1."

	| topView |
	topView := OomScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200.
	topView controller openIn: Rectangle fromUser! !

!OomScheduledController class methodsFor: 'examples' stamp: 'nishis 7/20/1998 04:43'!
example2
	"OomScheduledController example2."

	| topView subView |
	topView := OomScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200.
	subView := View new.
	topView borderWidth: 1.
	subView backgroundColor: Color white.
	topView addSubView: subView.
	topView controller openIn: Rectangle fromUser! !

!OomScheduledController class methodsFor: 'examples' stamp: 'nishis 7/20/1998 04:43'!
example3
	"OomScheduledController example3."

	| topView subView |
	topView := OomScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200.
	subView := View new.
	topView borderWidth: 1.
	subView backgroundColor: Color white.
	topView addSubView: subView.
	topView controller openAt: 100 @ 100! !
