'Oom010 (1/23/1999 6:20:39 pm)'.!


View subclass: #OomAokiMetricsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Tool'!
!OomAokiMetricsView commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomAokiMetricsView methodsFor: 'initialize-release' stamp: 'nishis 7/23/1998 00:27'!
scrollOffsetHolder: aValueHolder 
"	scrollOffset := aValueHolder.
	scrollOffset grid: [self scrollGrid].
	scrollOffset extraSpace: [self extraSpace]"! !


!OomAokiMetricsView methodsFor: 'accessing' stamp: 'nishis 7/23/1998 00:27'!
extraSpace
	^0 @ 0 corner: 0 @ 0! !

!OomAokiMetricsView methodsFor: 'accessing' stamp: 'nishis 7/23/1998 00:27'!
scrollGrid
	^8 @ 8! !


!OomAokiMetricsView methodsFor: 'display box accessing' stamp: 'nishis 7/23/1998 01:19'!
preferredBounds
	^0 @ 0 corner: self model imageSize + self marginRectangle origin + self marginRectangle corner + (1 @ 1)! !


!OomAokiMetricsView methodsFor: 'displaying' stamp: 'nishis 7/23/1998 01:19'!
displayCurrentPlaneOn: aGraphicsContext 
	self displayPlaneIndex: self model orderPlates last on: aGraphicsContext! !

!OomAokiMetricsView methodsFor: 'displaying' stamp: 'nishis 7/23/1998 03:28'!
displayLabelsOn: graphicsContext extent: extent x: x y: y 
	| offset style text space box |
	offset := self marginRectangle origin.
	style := self textStyle.
	text := (Paragraph withText: '0.0' asText style: style) centered.
	text foregroundColor: Color black backgroundColor: Color transparent.
	space := style lineGrid - style baseline.
	box := text boundingBox.
	box := box align: box bottomRight with: offset + (space negated @ 0).
	text displayOn: graphicsContext at: box origin.
	text := (Paragraph withText: '1.0' asText style: style) centered.
	text foregroundColor: Color black backgroundColor: Color transparent.
	box := text boundingBox.

	self model currentMode = #HFRFPF
		ifTrue: [box := box align: box bottomRight with: offset + (extent x @ 0)]
		ifFalse: [box := box align: box bottomCenter with: offset + (extent x @ 0)].
	text displayOn: graphicsContext at: box origin.
	box := box align: box rightCenter with: offset + (space negated @ extent y).
	text displayOn: graphicsContext at: box origin.
	text := (Paragraph withText: x asText style: style) centered.
	text foregroundColor: Color black backgroundColor: Color transparent.
	box := text boundingBox.
	box := box align: box bottomCenter with: offset + (extent x // 2 @ 0).
	text displayOn: graphicsContext at: box origin.
	text := (Paragraph withText: y asText style: style) centered.
	text foregroundColor: Color black backgroundColor: Color transparent.
	box := text boundingBox.
	box := box align: box rightCenter with: offset + (space negated @ (extent y // 2)).
	text displayOn: graphicsContext at: box origin""! !

!OomAokiMetricsView methodsFor: 'displaying' stamp: 'nishis 11/14/1998 12:41'!
displayOn: graphicsContext 
	| offset text box point image pf style space mode visibleAreas |
	offset := self marginRectangle origin.
	style := self textStyle.
	space := (style lineGrid - style baseline) * 2.
	mode := self model currentMode.
	mode = #HFRF
		ifTrue: 
			[self model plateHFRF displayOn: graphicsContext at: offset.
			self
				displayLabelsOn: graphicsContext
				extent: self model plateHFRF boundingBox extent
				x: 'HF'
				y: 'R\F' withCRs].
	mode = #PFRF
		ifTrue: 
			[self model platePFRF displayOn: graphicsContext at: offset.
			self
				displayLabelsOn: graphicsContext
				extent: self model platePFRF boundingBox extent
				x: 'PF'
				y: 'R\F' withCRs].
	mode = #HFPF
		ifTrue: 
			[self model plateHFPF displayOn: graphicsContext at: offset.
			self
				displayLabelsOn: graphicsContext
				extent: self model plateHFPF boundingBox extent
				x: 'HF'
				y: 'P\F' withCRs].
	mode = #HFRFPF
		ifTrue: 
			[self model orderPlates
				do: 
					[:index | 
					point := (index - 1 * self model plateInterval) asPoint.
					image := self model platesHFRFPF at: index.
					image displayOn: graphicsContext at: offset + point.
					pf := index - 1 / (self model plateSize - 1) roundTo: 0.01.
					text := (Paragraph withText: pf asFloat printString asText style: style) centered.
					text foregroundColor: Color black backgroundColor: Color transparent.
					box := text boundingBox.
					box := box align: box topLeft with: offset + (image boundingBox width + space @ (space negated * 2)) + point.
					text displayOn: graphicsContext at: box origin].
			self
				displayLabelsOn: graphicsContext
				extent: self model platesHFRFPF first boundingBox extent
				x: 'HF'
				y: 'R\F' withCRs.
			text := (Paragraph withText: 'PF' asText style: style) centered.
			box := text boundingBox.
			box := box align: box center with: offset + (space negated @ 0).
			box := box translateBy: self model platesHFRFPF first boundingBox width + 30 @ -10.
			box := box translateBy: self model imageSize - self model platesHFRFPF first boundingBox extent // 2.
			text displayOn: graphicsContext at: box origin].

	visibleAreas := self visibleAreas.
	visibleAreas 
		do: 
			[:rectangle | 
			graphicsContext
					displayOn: Display
					at: self insetDisplayBox origin 
					clippingBox: rectangle]! !

!OomAokiMetricsView methodsFor: 'displaying' stamp: 'nishis 7/23/1998 02:19'!
displayPlaneIndex: anInteger on: graphicsContext 
	| offset point image |
	self model currentMode = #HFRFPF
		ifTrue: 
			[offset := self marginRectangle origin.
			point := (anInteger - 1 * self model plateInterval) asPoint.
			image := self model platesHFRFPF at: anInteger.
			image displayOn: graphicsContext at: offset + point]! !

!OomAokiMetricsView methodsFor: 'displaying' stamp: 'nishis 7/23/1998 01:59'!
displayView
	| graphicsContext |
	graphicsContext := Form extent: self preferredBounds extent depth: 1.
	graphicsContext fillWithColor: self backgroundColor.
	self displayOn: graphicsContext! !


!OomAokiMetricsView methodsFor: 'controller accessing' stamp: 'nishis 7/23/1998 00:30'!
defaultControllerClass
	^OomAokiMetricsController! !


!OomAokiMetricsView methodsFor: 'updating' stamp: 'nishis 11/14/1998 12:42'!
update: aspectSymbol 
	| graphicsContext |
	graphicsContext := Form extent: self preferredBounds extent depth: 1.
	aspectSymbol = #order
		ifTrue: 
			[self displayCurrentPlaneOn: graphicsContext.
			self display.
			^self].
	super update: aspectSymbol.
	self display! !


!OomAokiMetricsView methodsFor: 'private' stamp: 'nishis 7/23/1998 00:30'!
marginRectangle
	^25 @ 25 corner: 25 @ 25! !

!OomAokiMetricsView methodsFor: 'private' stamp: 'nishis 7/23/1998 00:31'!
textStyle
	^TextStyle default copy! !


!OomAokiMetricsView methodsFor: 'private displaying' stamp: 'nishis 7/23/1998 02:02'!
visibleAreas
	| visibleAreas aRectangle outsides myTopController |
	visibleAreas := Array with: self insetDisplayBox.
	self topView notNil 
		ifTrue: [myTopController := self topView controller]
		ifFalse: [myTopController := self controller].
	(myTopController isKindOf: ModalController) 
		ifTrue: [^visibleAreas].
	(myTopController view class canUnderstand: #uncacheBits) 
		ifTrue: [myTopController view uncacheBits].
	ScheduledControllers scheduledWindowControllers 
		do:
			[:aControllers | 
			aControllers == myTopController ifTrue: [^visibleAreas].
			aRectangle := aControllers view windowBox.
			outsides := OrderedCollection new.
			visibleAreas 
				do: 
					[:area | 
					outsides addAll: (area areasOutside: aRectangle)].
			visibleAreas := outsides].
	^visibleAreas! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomAokiMetricsView class
	instanceVariableNames: ''!

!OomAokiMetricsView class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomAokiMetricsView class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomAokiMetricsView class methodsFor: 'copyright'!
version
	^'010'! !
