'Oom010 (1/23/1999 6:20:40 pm)'.!


OomMetricNOA subclass: #OomMetricNIV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Basic'!
!OomMetricNIV commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricNIV methodsFor: 'computing'!
computeNOA: aClass 
	"OomMetricNIV new computeNOA: Point."

	^aClass instVarNames size + aClass class instVarNames size! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricNIV class
	instanceVariableNames: ''!

!OomMetricNIV class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricNIV class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricNIV class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricNIV class methodsFor: 'description'!
description
	^'number of instance variables per class'! !

!OomMetricNIV class methodsFor: 'description'!
nickname
	^'NIV'! !


!OomMetricNIV class methodsFor: 'examples'!
example1
	"OomMetricNIV example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNIV classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricNIV class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:32'!
example2
	"OomMetricNIV example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNIV classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricNIV class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:17'!
example3
	"OomMetricNIV example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNIV classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricNIV class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:17'!
example4
	"OomMetricNIV example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNIV classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 10
				rank: 10.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
