'Oom010 (1/23/1999 6:20:40 pm)'.!


OomMetricNOM subclass: #OomMetricNCM
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Basic'!
!OomMetricNCM commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricNCM methodsFor: 'computing'!
computeNOM: aClass 
	"OomMetricNCM new computeNOM: Point."

	^aClass class selectors size! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricNCM class
	instanceVariableNames: ''!

!OomMetricNCM class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricNCM class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricNCM class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricNCM class methodsFor: 'description'!
description
	^'number of class methods per class'! !

!OomMetricNCM class methodsFor: 'description'!
nickname
	^'NCM'! !


!OomMetricNCM class methodsFor: 'examples'!
example1
	"OomMetricNCM example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNCM classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricNCM class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:32'!
example2
	"OomMetricNCM example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNCM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricNCM class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:18'!
example3
	"OomMetricNCM example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNCM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricNCM class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:18'!
example4
	"OomMetricNCM example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNCM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 30
				rank: 30.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
