'Oom010 (1/23/1999 6:20:41 pm)'.!


OomController subclass: #OomButtonController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Button'!
!OomButtonController commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomButtonController methodsFor: 'control defaults' stamp: 'nishis 7/25/1998 12:04'!
controlActivity
	(self sensor redButtonPressed and: [self viewHasCursor])
		ifTrue: [^self redButtonActivity].
	(self sensor yellowButtonPressed and: [self viewHasCursor])
		ifTrue: [^self yellowButtonActivity].
	(self sensor keyboardPressed and: [self viewHasCursor])
		ifTrue: [^self keyboardActivity].
	self idleActivity! !

!OomButtonController methodsFor: 'control defaults' stamp: 'nishis 7/25/1998 12:52'!
idleActivity
	"self poll"! !

!OomButtonController methodsFor: 'control defaults' stamp: 'nishis 11/14/1998 11:47'!
keyboardActivity
	| keyEvent action gc |
	sensor keyboardPressed ifFalse: [^ self].
	self model isEnabled ifFalse: [^self].
	keyEvent := sensor keyboard asciiValue.
     keyEvent == 13 ifTrue:
		[gc := Form extent: self view insetDisplayBox extent depth: Display depth.
		self view displayPressedOn: gc.
		(action := self model action) numArgs = 0
			ifTrue: [action value]
			ifFalse: [action value: self model]]! !

!OomButtonController methodsFor: 'control defaults' stamp: 'nishis 7/26/1998 02:10'!
redButtonActivity
	| gc box bool point action time |
	self model isEnabled ifFalse: [^true].
	gc := Form extent: self view insetDisplayBox extent depth: Display depth.
	box := self view insetDisplayBox.
	time := Time millisecondClockValue.
	point := self sensor cursorPoint.
	(bool := box containsPoint: point) ifFalse: [^false].
	[bool and: [self sensor anyButtonPressed]]
		whileTrue: 
			[point := self sensor cursorPoint.
			(bool := box containsPoint: point)
				ifTrue: [self view displayPressedOn: gc]
				ifFalse: [self view display].
			bool ifTrue: [
			point := self sensor cursorPoint.
			action := self model action.
			(self model repeatAction and: [Time millisecondClockValue - time > 500])
				ifTrue: [action numArgs = 0
						ifTrue: [action value]
						ifFalse: [action value: self model]]].
			bool := true].
	point := self sensor cursorPoint.
	(bool and: [box containsPoint: point])
		ifTrue: 
			[action := self model action.
			action numArgs = 0
				ifTrue: [action value]
				ifFalse: [action value: self model].
			^true].
	^false! !

!OomButtonController methodsFor: 'control defaults'!
yellowButtonActivity
	self redButtonActivity! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomButtonController class
	instanceVariableNames: ''!

!OomButtonController class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomButtonController class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomButtonController class methodsFor: 'copyright'!
version
	^'010'! !
