'Oom010 (1/23/1999 6:20:41 pm)'.!


OomMetricNOM subclass: #OomMetricNIM
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Basic'!
!OomMetricNIM commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricNIM methodsFor: 'computing'!
computeNOM: aClass 
	"OomMetricNIM new computeNOM: Point."

	^aClass selectors size! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricNIM class
	instanceVariableNames: ''!

!OomMetricNIM class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricNIM class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricNIM class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricNIM class methodsFor: 'description'!
description
	^'number of instance methods per class'! !

!OomMetricNIM class methodsFor: 'description'!
nickname
	^'NIM'! !


!OomMetricNIM class methodsFor: 'examples'!
example1
	"OomMetricNIM example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNIM classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricNIM class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:32'!
example2
	"OomMetricNIM example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNIM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricNIM class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:19'!
example3
	"OomMetricNIM example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNIM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricNIM class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:19'!
example4
	"OomMetricNIM example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNIM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 200
				rank: 20.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
