'Oom010 (1/23/1999 6:20:43 pm)'.!


OomListenerModel subclass: #OomBlockListener
	instanceVariableNames: 'block arguments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Models'!
!OomBlockListener commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomBlockListener methodsFor: 'initialize-release' stamp: 'nishis 11/14/1998 11:57'!
release
	"When and who send this message to me?"

	arguments do: [:argument | argument removeDependent: self].
	super release! !


!OomBlockListener methodsFor: 'accessing' stamp: 'nishis 7/27/1998 09:06'!
arguments
	arguments == nil ifTrue: [arguments := Array new].
	^arguments! !

!OomBlockListener methodsFor: 'accessing' stamp: 'nishis 7/28/1998 23:58'!
block
	^block! !

!OomBlockListener methodsFor: 'accessing' stamp: 'nishis 7/29/1998 00:48'!
value
	^self compute! !

!OomBlockListener methodsFor: 'accessing' stamp: 'nishis 7/29/1998 00:01'!
value: newValue
	^self shouldNotImplement! !


!OomBlockListener methodsFor: 'printing' stamp: 'nishis 7/29/1998 00:37'!
printOn: aStream 
	| name |
	name := self class name.
	aStream nextPutAll: ((name at: 1) isVowel
							ifTrue: ['an ']
							ifFalse: ['a '])
						, name.
	aStream nextPutAll: ' with: '.
	aStream nextPutAll: block printString! !


!OomBlockListener methodsFor: 'updating' stamp: 'nishis 7/29/1998 03:02'!
changed: aspectSymbol 
	| aContext |
	aContext := thisContext.
	(self isLoop: aContext sender context: aContext)
		ifFalse: 
			[self dependents 
				do: [:aDependent | aDependent update: aspectSymbol with: nil from: self]]! !

!OomBlockListener methodsFor: 'updating' stamp: 'nishis 7/29/1998 01:49'!
update: aspectSymbol 
	self compute.
	self changed: #value! !

!OomBlockListener methodsFor: 'updating' stamp: 'nishis 7/29/1998 03:41'!
update: aspectSymbol with: parameter from: sender 
	self update: aspectSymbol! !


!OomBlockListener methodsFor: 'private' stamp: 'nishis 7/29/1998 00:15'!
block: aBlock arguments: aCollection
	block := aBlock.
	arguments := aCollection.
	arguments do: [:argument | argument addDependent: self]! !

!OomBlockListener methodsFor: 'private' stamp: 'nishis 7/29/1998 03:13'!
compute
	^self block valueWithArguments: (self arguments collect: [:argument | argument value])! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomBlockListener class
	instanceVariableNames: ''!

!OomBlockListener class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomBlockListener class methodsFor: 'copyright' stamp: 'nishis 11/14/1998 13:33'!
readme
	"I am an fake BlockValue."

	"see useful messages below"
	"http://www.sra.co.jp/smalltalk/SML/mails/301-400/331.txt"
	"http://www.sra.co.jp/smalltalk/SML/mails/301-400/381.txt"! !

!OomBlockListener class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomBlockListener class methodsFor: 'copyright'!
version
	^'010'! !


!OomBlockListener class methodsFor: 'instance creation' stamp: 'nishis 7/28/1998 23:56'!
block: aBlock arguments: aCollection
	^self new block: aBlock arguments: aCollection! !

!OomBlockListener class methodsFor: 'instance creation' stamp: 'nishis 7/28/1998 23:57'!
with: aBlock
	^self new block: aBlock arguments: OrderedCollection new! !


!OomBlockListener class methodsFor: 'examples' stamp: 'nishis 7/29/1998 00:39'!
example1
	"OomBlockListner example1."

	| aListener |
	aListener := OomListener with: nil.
	aListener compute: [:v | Transcript cr; show: 'a = ', v printString].
	aListener value: 1.
	^aListener! !

!OomBlockListener class methodsFor: 'examples' stamp: 'nishis 11/14/1998 11:56'!
example2
	"OomBlockListener example2."

	| a b ab |
	a := OomListener with: 1.
	b := OomListener with: 2.
	ab := OomBlockListener block: [:va :vb | va * vb] arguments: (Array with: a with: b).
	ab compute: [:v | Transcript cr; show: 'ab = ', v printString].
	ab with: (OomListener with: 3) compute: [:v :c | Transcript cr; show: 'abc = ', (v * c) printString].
	a value: 10.
	b value: 20.
	a value: 20.
	b value: 30.
	^Array with: a with: b with: ab! !
