'Oom010 (1/23/1999 6:20:44 pm)'.!


OomDisplayController subclass: #OomTableController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Table'!
!OomTableController commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomTableController methodsFor: 'basic control sequence' stamp: 'nishis 7/21/1998 03:32'!
controlTerminate
	super controlTerminate.
	Cursor normal show! !


!OomTableController methodsFor: 'control defaults' stamp: 'nishis 7/22/1998 22:01'!
controlActivity
	super controlActivity.
	(self sensor anyButtonPressed and: [self viewHasCursor not])
		ifTrue: [^super controlActivity].
	(self sensor redButtonPressed and: [self viewHasCursor])
		ifTrue: [^self redButtonActivity].
	(self sensor yellowButtonPressed and: [self viewHasCursor])
		ifTrue: [^self yellowButtonActivity].
	(self sensor keyboardPressed and: [self viewHasCursor])
		ifTrue: [^self keyboardActivity].
	self idleActivity! !

!OomTableController methodsFor: 'control defaults' stamp: 'nishis 11/14/1998 12:15'!
idleActivity
	| rc cursor pointBlock point |
	cursor := Cursor currentCursor.
	pointBlock := 
		[point := Sensor cursorPoint - view insetDisplayBox topLeft + 
		(self horizontalScrollAmount @ self verticalScrollAmount).
		point yourself].
	rc := self whichCell: pointBlock value.
	(rc notNil and: [(rc x = 1 and: [rc y >= 2])
			or: [rc y = 1 and: [rc x >= 2]]])
		ifTrue: [cursor = Cursor crossHair ifFalse: [Cursor crossHair show]]
		ifFalse: [cursor = Cursor normal ifFalse: [Cursor normal show]]! !

!OomTableController methodsFor: 'control defaults' stamp: 'nishis 7/19/1998 13:03'!
keyboardActivity
	view handleKeystroke: sensor keyboard! !

!OomTableController methodsFor: 'control defaults' stamp: 'nishis 7/21/1998 03:47'!
redButtonActivity
	| point rc pointBlock |
	pointBlock := 
		[point := Sensor cursorPoint - view insetDisplayBox topLeft + 
		(self horizontalScrollAmount @ self verticalScrollAmount)].
	point := self sensor cursorPoint.
	point := pointBlock value.
	[self sensor redButtonPressed]
		whileTrue: 
			[point := pointBlock value.
			self idleActivity].
	rc := self whichCell: point.
	rc isNil ifTrue: [^self].
	(rc x = 1 and: [rc y >= 2])
		ifTrue: 
			[self controlTerminate.
			Cursor normal show.
			self model actionOnColumn: (self view cells atPoint: rc) last asString.
			self controlInitialize].
	(rc y = 1 and: [rc x >= 2])
		ifTrue: 
			[self controlTerminate.
			Cursor normal show.
			self model actionOnRow: (self view cells atPoint: rc) last asString.
			self controlInitialize]! !

!OomTableController methodsFor: 'control defaults' stamp: 'nishis 7/25/1998 01:58'!
yellowButtonActivity
	| menu selector |
	self model isNil ifTrue: [^self].
	(menu := self model yellowButtonMenu) isNil ifTrue: [^self].
	self controlTerminate.
	selector := menu startUp.
	(selector isNil or: [selector = 0])
		ifFalse: [self model perform: selector].
	self controlInitialize! !


!OomTableController methodsFor: 'private' stamp: 'nishis 7/19/1998 13:56'!
whichCell: aPoint 
	| point |
	point := aPoint - self view offset.
	self view cells doIJ: [:array :i :j | (array first containsPoint: point)
			ifTrue: [^i @ j]].
	^nil! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomTableController class
	instanceVariableNames: ''!

!OomTableController class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomTableController class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomTableController class methodsFor: 'copyright'!
version
	^'010'! !
